/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * SpatialCoverage
 */

public class SpatialCoverage {
  @JsonProperty("geom")
  private Object geom = null;

  @JsonProperty("granularity")
  private String granularity = "other";

  @JsonProperty("zones")
  private List<String> zones = null;

  public SpatialCoverage geom(Object geom) {
    this.geom = geom;
    return this;
  }

   /**
   * A multipolygon for the whole coverage
   * @return geom
  **/
  @ApiModelProperty(value = "A multipolygon for the whole coverage")
  public Object getGeom() {
    return geom;
  }

  public void setGeom(Object geom) {
    this.geom = geom;
  }

  public SpatialCoverage granularity(String granularity) {
    this.granularity = granularity;
    return this;
  }

   /**
   * The spatial/territorial granularity
   * @return granularity
  **/
  @ApiModelProperty(value = "The spatial/territorial granularity")
  public String getGranularity() {
    return granularity;
  }

  public void setGranularity(String granularity) {
    this.granularity = granularity;
  }

  public SpatialCoverage zones(List<String> zones) {
    this.zones = zones;
    return this;
  }

  public SpatialCoverage addZonesItem(String zonesItem) {
    if (this.zones == null) {
      this.zones = new ArrayList<String>();
    }
    this.zones.add(zonesItem);
    return this;
  }

   /**
   * The covered zones identifiers
   * @return zones
  **/
  @ApiModelProperty(value = "The covered zones identifiers")
  public List<String> getZones() {
    return zones;
  }

  public void setZones(List<String> zones) {
    this.zones = zones;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SpatialCoverage spatialCoverage = (SpatialCoverage) o;
    return Objects.equals(this.geom, spatialCoverage.geom) &&
        Objects.equals(this.granularity, spatialCoverage.granularity) &&
        Objects.equals(this.zones, spatialCoverage.zones);
  }

  @Override
  public int hashCode() {
    return Objects.hash(geom, granularity, zones);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SpatialCoverage {\n");

    sb.append("    geom: ").append(toIndentedString(geom)).append("\n");
    sb.append("    granularity: ").append(toIndentedString(granularity)).append("\n");
    sb.append("    zones: ").append(toIndentedString(zones)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

